︠6ca15357-d0c4-401b-8259-c1c5ca5d778ai︠
%html
<p>First, let's make simple analysis inside R. We have to use png drawing device and silent return value of dev.off function call, it's not necessary but reasonable thing to do.</p>

︡f5a8ff93-acfd-414f-b4cf-fade9d8c9f0a︡{"html": "<p>First, let's make simple analysis inside R. We have to use png drawing device and silent return value of dev.off function call, it's not necessary but reasonable thing to do.</p>"}︡
︠4b1be3d1-b392-43e6-b1d3-578d68ab1ef1︠
%r
x <- rnorm(100)
y <- rnorm(100, mean=5)*x+rnorm(100, mean=0.1)
png()
plot(y ~ x)
abline(lm(y ~ x), lwd=2)
.silent.me. <- dev.off()
︡bbc15bba-e45f-477a-9290-93dd1029da03︡︡
︠19de0666-662b-460f-ac43-755ca8dd0f09i︠
%html
<p>We will be accessing x and y inside Sage, so we need small interface functions on both R and Sage side:</p>

︡9a3b5578-ec0a-49e3-8f43-94b81e0c4cd2︡{"html": "<p>We will be accessing x and y inside Sage, so we need small interface functions on both R and Sage side:</p>"}︡
︠0922adf8-c420-4463-bf9a-5f53b5a1cd43︠
%r
letSage <- function(variable,value) { .GlobalEnv[[variable]]<-value }
getSage <- function(variable) { return(.GlobalEnv[[variable]]) }
︡9f54633f-2a83-47ae-ae72-60769032000e︡︡
︠56df93c3-b9cc-41c1-8b3f-bbd10fbf1138︠
def setR(variable, value):
    def prepare(x): 
        if isinstance(x, str): 
            return '"%s"'%x 
        elif isinstance(x, list):
            return map(prepare, x)
        else:
            return x 
    r.letSage(prepare(variable), prepare(value))
def getR(variable):
    if isinstance(variable, str):
        return(sageobj(r.getSage('"%s"'%variable)))
    else:
        return map(getR, variable)
︡9f36ed3d-3618-4245-a309-e3ea1e1d3d11︡︡
︠d58d4ee5-e385-4a95-a88f-d5d62cf68aa0i︠
%html
<p>We create copies of R variables in Sage:</p>

︡76fbe9b8-6ab8-4a39-ab01-07d905f6d785︡{"html": "<p>We create copies of R variables in Sage:</p>"}︡
︠bbd693f3-cee6-4468-a8c8-cfaa484a5167︠
x = getR("x")
y = getR("y")
x[0:9]
︡0e227848-9fa4-4194-9bfb-471e269662ab︡{"stdout": "[-0.95532848211007404, 0.22520393089409799, 0.69497116038785101, 1.1103934207403801, 1.06881750704875, -0.12758190055912999, 0.86809580969017297, -2.4568662537613699, -0.231569422766398]"}︡
︠674b0770-0c89-4996-9540-417c904421eai︠
%html
<p>We have to look out for starting indices on both sides!</p>

︡a65ee4d1-d262-46b8-a4ae-bd47c2484941︡{"html": "<p>We have to look out for starting indices on both sides!</p>"}︡
︠0a6f12b9-6814-4de2-af11-1ccaed8d5482︠
%r
x[1]
︡d458d177-0508-41b6-8644-8e0cd9b85c9d︡{"stdout": "[1] -0.9553285"}︡
︠082c67e9-1124-422f-9db5-2afeb0ff3b23︠
x[0]
︡ef65e0df-a03d-403d-9a70-b74628390f9c︡{"stdout": "-0.95532848211007404"}︡
︠4ce5e8e4-1436-446c-a1ca-73723ba5f673i︠
%html
<p>Also, remember that those are copies of variables, not references!</p>

︡0fd7147b-6cea-4d08-974f-451acc8f3a77︡{"html": "<p>Also, remember that those are copies of variables, not references!</p>"}︡
︠38c6a807-154b-45b5-9880-2775fb737561︠
x[0]=round(x[0],ndigits=2); x[0]
︡a73698df-7acf-4f9f-82dc-f9d5b799f63d︡{"stdout": "-0.96"}︡
︠57dcfe35-a137-4465-93a9-0bfc6fad0bb3︠
%r
x[1]
︡cd717f1e-788b-48f4-ac1c-514630b51170︡{"stdout": "[1] -0.9553285"}︡
︠036ba999-f908-47af-9a0f-fe1784772423i︠
%html
<p>But of course we can copy those values back to R:</p>

︡96f1d7fd-41d8-4dbf-878a-524e45a8d793︡{"html": "<p>But of course we can copy those values back to R:</p>"}︡
︠d1bcb409-2ef2-4957-b81e-3565ee5e0e5c︠
setR("x", x)
︡d89d0272-5107-40d8-ac11-a5b16be60336︡︡
︠9cfd20d4-4a42-4638-b824-bdbdc0bb8c31︠
%r
x[1]
︡eb189958-a1ef-48a0-89bc-611fe3a27322︡{"stdout": "[1] -0.96"}︡
︠1f71d344-0827-4566-8efe-0aa4a1877735i︠
%html
<p>That way, we can make a plot of same data using Sage plotting capabilities:</p>

︡6f8a8f03-e3c3-41ac-a919-f713fa3db79e︡{"html": "<p>That way, we can make a plot of same data using Sage plotting capabilities:</p>"}︡
︠6f9232e2-e072-416d-9e19-37740d4cdf72︠
plot(points(zip(x,y)))
︡0b58754a-1c4e-45fb-b6e7-f015c31075a2︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠f3781bcc-0d8b-4d56-abc4-732cfd1f288ai︠
%html
<p>Or using "r-dot" interface:</p>

︡facae143-46f5-4f30-ba84-dc4d0f6748bf︡{"html": "<p>Or using \"r-dot\" interface:</p>"}︡
︠9ad591c7-61a2-47d5-a115-1d3e29511788︠
r.png()
r.plot(x, y)
_=r.dev_off()
︡3abdb621-bc4c-42cd-9ee1-ae6427058a00︡︡
︠740ea24d-2aeb-4404-8c4a-3b7f1ebec6cci︠
%html
<p>But remember that such call creates new variables named sage* inside Rs environment:</p>

︡9ca43671-4123-4592-8cff-16ae1a3fab38︡{"html": "<p>But remember that such call creates new variables named sage* inside Rs environment:</p>"}︡
︠2f3ca5d9-7ca7-4149-ab2b-a18147b65db2︠
%r
ls()
︡b8a067c1-c5a1-4675-a4d3-26f06aec9a70︡{"stdout": "[1] \"getSage\" \"letSage\" \"sage0\"   \"sage1\"   \"sage10\"  \"sage100\" \"sage101\" \"sage102\" \"sage103\"\n [10] \"sage104\" \"sage105\" \"sage106\" \"sage107\" \"sage108\" \"sage109\" \"sage11\"  \"sage110\" \"sage111\"\n [19] \"sage112\" \"sage113\" \"sage114\" \"sage115\" \"sage116\" \"sage117\" \"sage118\" \"sage119\" \"sage12\" \n [28] \"sage120\" \"sage121\" \"sage122\" \"sage123\" \"sage124\" \"sage125\" \"sage126\" \"sage127\" \"sage128\"\n [37] \"sage129\" \"sage13\"  \"sage130\" \"sage131\" \"sage132\" \"sage133\" \"sage134\" \"sage135\" \"sage136\"\n [46] \"sage137\" \"sage138\" \"sage139\" \"sage14\"  \"sage140\" \"sage141\" \"sage142\" \"sage143\" \"sage144\"\n [55] \"sage145\" \"sage146\" \"sage147\" \"sage148\" \"sage149\" \"sage15\"  \"sage150\" \"sage151\" \"sage152\"\n [64] \"sage153\" \"sage154\" \"sage155\" \"sage156\" \"sage157\" \"sage158\" \"sage159\" \"sage16\"  \"sage160\"\n [73] \"sage161\" \"sage162\" \"sage163\" \"sage164\" \"sage165\" \"sage166\" \"sage167\" \"sage168\" \"sage169\"\n [82] \"sage17\"  \"sage170\" \"sage171\" \"sage172\" \"sage173\" \"sage174\" \"sage175\" \"sage176\" \"sage177\"\n [91] \"sage178\" \"sage179\" \"sage18\"  \"sage180\" \"sage181\" \"sage182\" \"sage183\" \"sage184\" \"sage185\"\n[100] \"sage186\" \"sage187\" \"sage188\" \"sage189\" \"sage19\"  \"sage190\" \"sage191\" \"sage192\" \"sage193\"\n[109] \"sage194\" \"sage195\" \"sage196\" \"sage197\" \"sage198\" \"sage199\" \"sage2\"   \"sage20\"  \"sage200\"\n[118] \"sage201\" \"sage202\" \"sage21\"  \"sage22\"  \"sage23\"  \"sage24\"  \"sage25\"  \"sage26\"  \"sage27\" \n[127] \"sage28\"  \"sage29\"  \"sage3\"   \"sage30\"  \"sage31\"  \"sage32\"  \"sage33\"  \"sage34\"  \"sage35\" \n[136] \"sage36\"  \"sage37\"  \"sage38\"  \"sage39\"  \"sage4\"   \"sage40\"  \"sage41\"  \"sage42\"  \"sage43\" \n[145] \"sage44\"  \"sage45\"  \"sage46\"  \"sage47\"  \"sage48\"  \"sage49\"  \"sage5\"   \"sage50\"  \"sage51\" \n[154] \"sage52\"  \"sage53\"  \"sage54\"  \"sage55\"  \"sage56\"  \"sage57\"  \"sage58\"  \"sage59\"  \"sage6\"  \n[163] \"sage60\"  \"sage61\"  \"sage62\"  \"sage63\"  \"sage64\"  \"sage65\"  \"sage66\"  \"sage67\"  \"sage68\" \n[172] \"sage69\"  \"sage7\"   \"sage70\"  \"sage71\"  \"sage72\"  \"sage73\"  \"sage74\"  \"sage75\"  \"sage76\" \n[181] \"sage77\"  \"sage78\"  \"sage79\"  \"sage8\"   \"sage80\"  \"sage81\"  \"sage82\"  \"sage83\"  \"sage84\" \n[190] \"sage85\"  \"sage86\"  \"sage87\"  \"sage88\"  \"sage89\"  \"sage9\"   \"sage90\"  \"sage91\"  \"sage92\" \n[199] \"sage93\"  \"sage94\"  \"sage95\"  \"sage96\"  \"sage97\"  \"sage98\"  \"sage99\"  \"x\"       \"y\""}︡
︠663e2fd0-17b3-41c8-8cc9-ece852886604i︠
%html
<p>There is also one thing to look out for, passing strings. If you pass strings as it, using "value", expect to get something like:</p>

︡0fbd4234-93b4-4f07-9053-b5e96b35aba2︡{"html": "<p>There is also one thing to look out for, passing strings. If you pass strings as it, using \"value\", expect to get something like:</p>"}︡
︠54ed980a-3c0d-4dee-8da6-3e588d36e844︠
r.png()
r.plot(x, y, xlab="x", ylab="y")
_=r.dev_off()
︡98b9118b-d8cb-4885-afc8-63f4e8e621fd︡︡
︠5a3207b6-493f-42cc-ada0-d821c2cdc40ci︠
%html
<p>or:</p>

︡95f24186-0ecb-4c1b-a941-494666234628︡{"html": "<p>or:</p>"}︡
︠0ada22e0-104c-4f62-8fad-63fbbfbb643f︠
r.png()
r.plot(x, y, xlab="the x", ylab="the y")
_=r.dev_off()
︡163dd8a6-4a71-4262-8fec-5f7bca846fe7︡︡
︠ced66060-7b65-43a2-a4fc-9176b2f53f57i︠
%html
<p>To get the names, you have to quote the quotes, so use '"value"' or "'value'" like in:</p>

︡23f3c249-1827-496b-95f8-ea6259959c42︡{"html": "<p>To get the names, you have to quote the quotes, so use '\"value\"' or \"'value'\" like in:</p>"}︡
︠70b83080-054c-4118-97c1-63d2f51427eb︠
r.png()
r.plot(x, y, xlab='"x"', ylab="'y'")
_=r.dev_off()
︡aebdf649-6e94-4e7b-aefc-356f267d79b5︡︡
︠82445ed9-1200-4582-aaa4-fffd30521f42i︠
%html
<p>It's not much, but actually it is enough to get you started if you  already know R and want to use it from Sage.</p>

︡4d1a0a07-8fb3-41b2-b1e4-a81072d651fb︡{"html": "<p>It's not much, but actually it is enough to get you started if you  already know R and want to use it from Sage.</p>"}︡
